/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_draw_object_info.h"
#include  <stdio.h>
#include  "../common/graphics/gl_win.h"
#include  "mtk_mode.h"
#include  "mtk_objects.h"
#include  "mtk_target.h"
#include  "mtk_font.h"







const char  szObjType[][20] = {
	"None",

	"Floating Object",
	"Sun",
	"Planet",
	"Satellite",
	"Small Body",
	"Oort Cloud",
	"Star",
	"Globular Cluster",
	"Our Galaxy",
	"Nearby Galaxy",
	"Distant Galaxy",
	"Spacecraft",

	"Fixed Object",
	"Scale",
	"Label"
};




void
draw_selected_object_info(const mtk_draw_struct& ds)
{
	const int csN = 10;
	static bool bFirst = true;
	static float cs[csN], sn[csN];
	if (bFirst) {
		bFirst = false;

		for (int i=0; i<csN; i++) {
			float th = 0.5*M_PI * float(i)/(csN-1);
			cs[i] = cos(th);
			sn[i] = sin(th);
		}
	}


	float a = min(ds.w, ds.h);
	float fac = (a < 200) ? a/200 : 1.0;

	const float sub_size = 0.7f * fac;
	const float text_size = 21.0f * fac;
	const float spc1 = 0.4f;
	const float spc2 = 0.2f;
	const float line_width = 1.0 * fac;


	//***** Planetarium mode ́A܂ΉĂȂ
	if (ds.tyMode != MODE_3D)  return;
	//*****
	if ( !is_there_selected_object() )  return;
	const mtk_object&  obj = get_selected_object();



	//---  Make text  ---
	std::vector<std::string>  text;
	obj.make_object_info(ds, text);
	if (text.size() <= 0.0)  return;


	//---  Hit position  ---
	int mx, my;
	get_object_hit_pos(&mx, &my);

	float dx1, dy1;
	dx1 = 0.6 * text_size;
	dy1 = 0.6 * text_size;

	float mgn_x, mgn_y;
	mgn_x = 0.3 * text_size;
	mgn_y = 0.3 * text_size;

	//---  Calc size  ---
	float w, h, wt, ht;

	wt = 0.0f;
	for (int i=0; i<text.size(); i++) {
		get_text_size(text[i].c_str(), w, h);
		if (i >= 1)  w *= sub_size;
		if (wt < w)  wt = w;
	}

	ht = 1.0f + spc1 + sub_size * ((text.size() - 1) + (text.size() - 2)*spc2);

	wt *= text_size;
	ht *= text_size;

	//---
	float x1, y1, x2, y2, wm, hm;
	x1 = float(mx) - mgn_x + dx1;
	y1 = float(my) - mgn_y + dy1;
	x2 = x1 + wt + mgn_x;
	y2 = y1 + ht + mgn_y;
	wm = wt + 2*mgn_x;
	hm = ht + 2*mgn_y;


	//-- Adjust position
	float mgn_xx = 0.7*mgn_x;
	float mgn_yy = 0.7*mgn_y;
	if (x2+mgn_x+mgn_xx > ds.w) {
		x2 = ds.w - mgn_xx - mgn_x;
		x1 = x2 - wt - mgn_x;
	}
	if (y2+mgn_y+mgn_yy > ds.h) {
		y2 = ds.h - mgn_yy - mgn_y;
		y1 = y2 - ht - mgn_y;
	}


	//---  Draw  ---
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);

	gl_enter_2D_mode();
		glTranslatef(x1, y1, 0);

		//glColor4f(0, 0, 0.3, 0.7);
		//glColor4f(0, 0.3, 0.2, 0.8);
		glColor4f(0, 0.15, 0.23, 0.9);
		glBegin(GL_QUADS);
			//-- upper
			glVertex2f(mgn_x,    0);
			glVertex2f(mgn_x+wt, 0);
			glVertex2f(mgn_x+wt, mgn_y);
			glVertex2f(mgn_x,    mgn_y);
			//-- main body
			glVertex2f( 0,  mgn_y +text_size);
			glVertex2f(wm,  mgn_y +text_size);
			glVertex2f(wm,  ht+mgn_y);
			glVertex2f( 0,  ht+mgn_y);
			//-- lower
			glVertex2f(mgn_x,    ht+mgn_y);
			glVertex2f(mgn_x+wt, ht+mgn_y);
			glVertex2f(mgn_x+wt, hm);
			glVertex2f(mgn_x,    hm);
		glEnd();

		//-- Corner UL
		float Rx = mgn_x;
		float Ry = mgn_y;
		float xc, yc;
		xc = mgn_x;
		yc = mgn_y;
		glBegin(GL_TRIANGLE_FAN);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float x = -Rx*cs[i] + xc;
			float y = -Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();

		//-- Corner UR
		xc = mgn_x + wt;
		yc = mgn_y;
		glBegin(GL_TRIANGLE_FAN);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float x =  Rx*cs[i] + xc;
			float y = -Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();

		//-- Corner BR
		xc = mgn_x;
		yc = mgn_y + ht;
		glBegin(GL_TRIANGLE_FAN);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float x = -Rx*cs[i] + xc;
			float y =  Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();

		//-- Corner BR
		xc = mgn_x + wt;
		yc = mgn_y + ht;
		glBegin(GL_TRIANGLE_FAN);
		glVertex3f(xc, yc, 0);
		for (int i=0; i<csN; i++) {
			float x =  Rx*cs[i] + xc;
			float y =  Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();


		//--  Hi-light
		glBegin(GL_QUADS);
			glColor4f(0, 0.4, 0.7, 1.0);
			//glColor4f(0, 0.8, 0.6, 0.95);
			//glColor4f(0, 0.5, 0, 0.9);
			//glColor4f(0.8, 0.6, 0, 0.9);
			glVertex2f( 0,  mgn_y);
			glVertex2f(wm,  mgn_y);
			//glColor4f(0.5, 0.4, 0, 0.8);
			//glColor4f(0, 0.3, 0, 0.8);
			glColor4f(0, 0.25, 0.4, 0.95);
			glVertex2f(wm,  mgn_y +text_size);
			glVertex2f( 0,  mgn_y +text_size);
		glEnd();



		//--  Line
		glColor4f(0, 0.4, 0.7, 1.0);
		glLineWidth( line_width );
		glBegin(GL_LINES);
			glVertex3f(mgn_x, 0, 0);
			glVertex3f(wt+mgn_x, 0, 0);

			glVertex3f(mgn_x, hm, 0);
			glVertex3f(wt+mgn_x, hm, 0);

			glVertex3f(0, mgn_y, 0);
			glVertex3f(0, mgn_y+ht, 0);

			glVertex3f(wm, mgn_y, 0);
			glVertex3f(wm, mgn_y+ht, 0);
		glEnd();


		//-- Corner UL
		xc = mgn_x;
		yc = mgn_y;
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<csN; i++) {
			float x = -Rx*cs[i] + xc;
			float y = -Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();

		//-- Corner UR
		xc = mgn_x + wt;
		yc = mgn_y;
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<csN; i++) {
			float x =  Rx*cs[i] + xc;
			float y = -Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();

		//-- Corner DL
		xc = mgn_x;
		yc = mgn_y + ht;
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<csN; i++) {
			float x = -Rx*cs[i] + xc;
			float y =  Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();

		//-- Corner UR
		xc = mgn_x + wt;
		yc = mgn_y + ht;
		glBegin(GL_LINE_STRIP);
		for (int i=0; i<csN; i++) {
			float x =  Rx*cs[i] + xc;
			float y =  Ry*sn[i] + yc;
			glVertex3f(x, y, 0);
		}
		glEnd();






		glTranslatef(mgn_x, mgn_y, 0);
		glScalef(text_size, -text_size, text_size);
		glTranslatef(0,-1,0);
		glTranslatef(0,0.1,0);


		//---  Name  ---
		glColor4f(1, 1, 1, 1);
		glPushMatrix();
			draw_text( text[0].c_str() );
		glPopMatrix();


		glScalef(sub_size, sub_size, sub_size);
		glTranslatef(0,-1-spc1,0);
		if (text.size() >= 1) {
			//---  Text  ---
			for (int i=1; i<text.size(); i++) {
				glPushMatrix();
					draw_text( text[i].c_str() );
				glPopMatrix();
				if (i < text.size()-1)  { glTranslatef(0,-1-spc2,0); }
			}
		}


		/*
		glTranslatef(0,-1,0);
		glPushMatrix();
			sprintf(str, "Target ID = %d", get_target_ID());
			draw_text(str);
		glPopMatrix();
		glTranslatef(0,-1,0);
		

		glPushMatrix();
			sprintf(str, "Object type = %s", szObjType[obj.get_type()]);
			draw_text(str);
		glPopMatrix();

		glTranslatef(0,-1,0);
		glPushMatrix();
			sprintf(str, "index = %d", obj.get_index());
			draw_text(str);
		glPopMatrix();

		glTranslatef(0,-1,0);
		glPushMatrix();
			sprintf(str, "obj num (near) = %d", obj_num_near);
			draw_text(str);
		glPopMatrix();

		glTranslatef(0,-1,0);
		glPushMatrix();
			sprintf(str, "obj num (far) = %d", obj_num_far);
			draw_text(str);
		glPopMatrix();

		glTranslatef(0,-1,0);
		glPushMatrix();
			sprintf(str, "%d targetable objects", obj_num_tgt);
			draw_text(str);
		glPopMatrix();
		*/
	gl_leave_2D_mode();

	glEnable(GL_DEPTH_TEST);
}
