/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  <tchar.h>
#include  <stdio.h>
#include  <dshow.h>
#include  <atlbase.h>
#include  "mtk_movie.h"

#include  "mtk_movement.h"






#define SAFE_RELEASE(x) { if (x) x->Release(); x = NULL; }





//==============
//  DirectShow
//==============
void
movie::ReleaseDirectShow()
{
	if (pMC)	pMC->Stop();

	if (pVW) {
		pVW->put_Visible(OAFALSE);
		pVW->put_Owner(NULL);
	}

	if (pEv) {
        pEv->SetNotifyWindow( (OAHWND)NULL, 0,0 );
	}

	SAFE_RELEASE(pEv);
    SAFE_RELEASE(pMS);
    SAFE_RELEASE(pMC);
    SAFE_RELEASE(pBV);
    SAFE_RELEASE(pBA);
    SAFE_RELEASE(pVW);
    SAFE_RELEASE(pWC);
    SAFE_RELEASE(pMix);
    SAFE_RELEASE(pGB);
}



// x0,y0,w,h ́ÃEBhËʒuƃTCY
bool
movie::open(const char* filename, HWND hOwnerWindow, int x0, int y0, int w, int h, UINT u_WM_NOTIFY, bool bWindowlessVMR)
{
    HRESULT  hr;
	
	ReleaseDirectShow();

	//-- Convert filename to wide character string
	WCHAR wFile[MAX_PATH];
	wcscpy( wFile, CA2W(filename) );

	
	//--  tB^Ot}l[W𐶐
	CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (void**)&pGB );
	if (pGB==NULL) {
		ReleaseDirectShow();
		return  false;
	}

	if (bWindowlessVMR) {
		if (FAILED( InitializeWindowlessVMR(hOwnerWindow) )) {
			ReleaseDirectShow();
			return false;
		}
	}


	hr = pGB->RenderFile( wFile, NULL );
	if (hr != S_OK)  {
		ReleaseDirectShow();
		return false;
	}

	//-- Create interfaces
	pGB->QueryInterface(IID_IMediaControl,	(void**)&pMC);
	pGB->QueryInterface(IID_IMediaEventEx,	(void**)&pEv);
	if (!bWindowlessVMR) {
		pGB->QueryInterface(IID_IVideoWindow,	(void**)&pVW);
		pGB->QueryInterface(IID_IBasicVideo,	(void**)&pBV);
	}
	pGB->QueryInterface(IID_IBasicAudio,	(void**)&pBA);
	pGB->QueryInterface(IID_IMediaSeeking,  (void**)&pMS);

	// [r[ǂ̊mF
	if (!bWindowlessVMR) {
		if ((!pVW) || (!pBV)) {
			bMovie = false;
		} else {
			long lVisible;
			hr = pVW->get_Visible(&lVisible);
			if (FAILED(hr))		bMovie = false;
			else				bMovie = true;
		}
	} else {
		if (!pWC) {
			bMovie = false;
		} else {
			bMovie = true;
		}
	}


	//-- TCY̎擾
	long lw, lh;
	if (!bWindowlessVMR) {
		hr = pBV->GetVideoSize(&lw, &lh);
		if (hr == E_NOINTERFACE) return false;
	} else {
		hr = pWC->GetNativeVideoSize(&lw, &lh, NULL, NULL);
		if (hr == E_NOINTERFACE) return false;
	}


	//-- EBhEɃtBbgiɔzuj
	float rt_wn = float(h)/float(w);
	float rt_mv = float(lh)/float(lw);
	if (rt_mv > rt_wn) {
		// EBhE[r[̕c
		mvw = int(h/rt_mv);
		mvh = h;
	} else {
		// [r[EBhE̕c
		mvw = w;
		mvh = int(w*rt_mv);
	}


	int dx, dy;
	dx = (w - mvw)/2;
	dy = (h - mvh)/2;
	mvx = x0 + dx;
	mvy = y0 + dy;



	//-- Set view window
	if (!bWindowlessVMR) {
		if (is_movie()) {
			pVW->put_Visible(OAFALSE);
			pVW->put_Owner( (OAHWND)hOwnerWindow );
			pVW->put_WindowStyle( WS_CHILD | WS_CLIPSIBLINGS );
			pVW->SetWindowPosition(mvx, mvy, mvw, mvh);
			pVW->HideCursor(OATRUE);
		}
	} else {
		if (is_movie()) {
			
			RECT rect;
			GetClientRect(hOwnerWindow, &rect);
			rect.left	= mvx;
			rect.right	= mvx + mvw;
			rect.bottom	= mvy + mvh;
			rect.top	= mvy -1;	//*****

			hr = pWC->SetVideoPosition(NULL, &rect);

		}
	}

	//-- Set signal event
	pEv->SetNotifyWindow( (OAHWND)hOwnerWindow, u_WM_NOTIFY, 0);

	pMS->GetStopPosition( &end_pos );	// Iʒu擾

	pMC->Pause();

	if (!bWindowlessVMR) {
		if (is_movie()) {
			pVW->put_Visible(OATRUE);		// EBhE\
		}
	} else {
		if (is_movie()) {
			InvalidateRect(hOwnerWindow, NULL, false);
		}
	}


	return  true;
}






//=========
//  Movie
//=========
void
movie::play()
{
	if (!pMC)	return;
	if (pVW)	pVW->put_Visible(OATRUE);		// EBhE\
	pMC->Run();
}

void
movie::pause()
{
	if (!pMC)  return;
	
	pMC->Pause();
}

void
movie::home()
{
	if (pMC==NULL || pMS==NULL)  return;

	pMC->Pause();
	LONGLONG  pos=0;
	pMS->SetPositions( &pos, AM_SEEKING_AbsolutePositioning, NULL, AM_SEEKING_NoPositioning );
}

void
movie::end()
{
	if (pMC==NULL || pMS==NULL)  return;

	pMC->Pause();
	pMS->SetPositions( &end_pos, AM_SEEKING_AbsolutePositioning, NULL, AM_SEEKING_NoPositioning );
}

void
movie::close()
{
	ReleaseDirectShow();
	end_pos = 0;
}




LONGLONG
movie::get_position() const
{
	if (pMS==NULL)  return 0;

	LONGLONG pos;
	pMS->GetCurrentPosition(&pos);
	return pos;
}

void
movie::set_position(LONGLONG pos)
{
	if (pMC==NULL || pMS==NULL)  return;

	pMC->Pause();
	pMS->SetPositions(&pos, AM_SEEKING_AbsolutePositioning | AM_SEEKING_SeekToKeyFrame, NULL, AM_SEEKING_NoPositioning);
}



bool
movie::get_event(long& evCode, long& prm1, long& prm2)
{
	if (pEv==NULL)  return false;
	if ( !SUCCEEDED( pEv->GetEvent( &evCode, &prm1, &prm2, 0) )	)	return false;
	if ( !SUCCEEDED( pEv->FreeEventParams( evCode, prm1, prm2 ) ))	return false;

	return true;
}

HRESULT
movie::InitializeWindowlessVMR(HWND hOwnerWindow)
{
	IBaseFilter* pVMR = NULL;

	HRESULT hr = CoCreateInstance(CLSID_VideoMixingRenderer, NULL,
					CLSCTX_INPROC, IID_IBaseFilter, (void**)&pVMR);

	if (SUCCEEDED(hr)) {
		hr = pGB->AddFilter(pVMR, L"Video Mixing Renderer");
		if (SUCCEEDED(hr)) {
			IVMRFilterConfig* pConfig;

			hr = pVMR->QueryInterface(IID_IVMRFilterConfig, (void**)&pConfig);
			if (SUCCEEDED(hr)) {
				hr = pConfig->SetRenderingMode(VMRMode_Windowless);

				//****
				hr = pConfig->SetNumberOfStreams(1);
				pConfig->Release();
			}


			hr = pVMR->QueryInterface(IID_IVMRWindowlessControl, (void**)&pWC);
			if (SUCCEEDED(hr)) {
				hr = pWC->SetVideoClippingWindow(hOwnerWindow);
				hr = pWC->SetBorderColor(RGB(0,0,0));
			}
			
			hr = pVMR->QueryInterface(IID_IVMRMixerControl, (void**)&pMix);
			if (SUCCEEDED(hr)) {
				DWORD dwPrefs = 0;
				hr = pMix->GetMixingPrefs(&dwPrefs);

				if (SUCCEEDED(hr)) {
					dwPrefs |= MixerPref_PointFiltering;
					dwPrefs &= ~(MixerPref_BiLinearFiltering);

					hr = pMix->SetMixingPrefs(dwPrefs);

					hr = pMix->SetAlpha(0, GetMovieFadeAlpha());
				}
			}
		} else {
			//...
		}
		pVMR->Release();
	}

	return  hr;
}



void
movie::OnPaint(HWND hWnd, HDC hDC)
{
	if (pMC && pWC && pMS) {

		OAFilterState  fs;
		pMC->GetState(INFINITE, &fs);

		if (fs != 2) {
			LONGLONG pos;
			if (pMS) pMS->GetCurrentPosition(&pos);
			if (pMS) pMS->SetPositions(&pos, AM_SEEKING_AbsolutePositioning | AM_SEEKING_SeekToKeyFrame, NULL, AM_SEEKING_NoPositioning);
		}
	}
	if (pMix) {
		pMix->SetAlpha(0, GetMovieFadeAlpha());
	}
	if (pWC) {
		pWC->RepaintVideo(hWnd, hDC);
	}
}




//---------------
//  Media  File
//---------------
bool
MediaFiles::open_info_file(const directory& dir, const char* fn)
{
	FILE* fp = dir.fopen(fn, "rt");
	if (fp==NULL)  return false;
	clear();


	char one_line[512];
	int count;


	//-- efBAt@C̏擾
	while (true) {
		media_file_info  mfi;
		char mfn[MAX_PATH+1], mfn2[MAX_PATH+1], type[20], menu_title[256], disp_title[256];

		if (fgets(one_line, 512, fp) == NULL)  break;
		count = sscanf(one_line, "%s %s %s %s %s", mfn, mfn2, type, menu_title, disp_title);
		if (count != 5)  continue;

		switch (type[0]) {
			case 'I':	case 'i':		mfi.type = MEDIATYPE_IMAGE;				break;
			case 'P':	case 'p':		mfi.type = MEDIATYPE_POPUP_IMAGE;		break;
			case 'M':	case 'm':		mfi.type = MEDIATYPE_MOVIE;				break;
			case 'A':	case 'a':		mfi.type = MEDIATYPE_AUDIO;				break;
			default:															continue;
		}

		strcpy(mfi.filename,  dir.get_path(mfn));
		strcpy(mfi.filename2, dir.get_path(mfn2));
		strcpy(mfi.menu_title, menu_title);
		strcpy(mfi.disp_title, disp_title);
		push_back(mfi);

        if (size() > media_files_max) break;
	}

	fclose(fp);
	return  true;
}


bool
MediaFiles::load_pathfile(int idx, char file_path[][MAX_PATH], bool bSubtitlesMode)  const
{
	if (idx<0 || idx>=size())  return false;

	const char* filename = (!bSubtitlesMode)  ?  (*this)[idx].filename  :  (*this)[idx].filename2;

	FILE *fp;
	if ( (fp=fopen(filename, "rt"))==NULL )   return false;
	
	int i=0;
	while (true) {
		char ch;
		char* p = file_path[i];
		while ( (ch=getc(fp))!= '\n' && ch!=EOF ) {
            *p++ = ch;
		}
		*p = '\0';
		i++;
		if (ch==EOF)  break;
	}
	fclose(fp);
	return  true;
}
