/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_SATELLITE_DATA_H__
#define __MTK_SATELLITE_DATA_H__
#include  "../common/math/vector3.h"
#include  "../common/bilingual.h"





//--------------
//  Orbit type
//--------------
enum {
	SAT_ORBIT_MOON,
	SAT_ORBIT_ECLIPTIC,
	SAT_ORBIT_LAPLACE,
	SAT_ORBIT_EQUATORIAL,
	SAT_ORBIT_ICRF
};




//------------------
//  Satellite data
//------------------
struct satellite_data {
	//---  planet ID
	const char*	planet_key;	// planet key

	//---  satellite key
	const char* key;

	//---  name
	bilingual name;

	//---  texture
	const char*	texture_name;	// texture filename

	//---  Phys params
	double	Rx, Ry, Rz;			// size(radius, in km): fAA]

	//---  orbital elements
	int		orbit_type;	// type
	double	epoch;		// epoch
	double	a;			// semi-major axisiOaj
	double	e;			// eccentricityiSj
	double	omg;		// argument of periapsisiߓ_j
	double	M0;			// mean anomalyiϋߓ_pj
	double	i;			// inclinationireference plane ɑ΂OXΊpj
	double	node;		// longitude of the ascending nodei_:reference planeICRF equator node 瑪pxj
	double	n;			// mean daily motioniϓX^j
	double	P;			// sidereal periodiiPNjj
	double	Pw;			// argument of periapsis precession period
	double	Pnode;		// longitude of the ascending node precession period
	double	RA;			// right ascension
	double	DEC;		// declination of the Laplace plane pole with respect to the ICRF
};




//
enum
{
	SAT_MOON,
	
	SAT_PHOBOS,
	SAT_DEIMOS,

	SAT_IO,
	SAT_EUROPA,
	SAT_GANYMEDE,
	SAT_CALLISTO,
	SAT_AMALTHEA,
	SAT_THEBE,
	SAT_ADRASTEA,
	SAT_METIS,
	SAT_HIMALIA,
	SAT_ELARA,
	SAT_PASIPHAE,
	SAT_SINOPE,
	SAT_LYSITHEA,
	SAT_CARME,
	SAT_ANANKE,
	SAT_LEDA,
	SAT_CALLIRRHOE,
	SAT_THEMISTO,
	SAT_MAGACLITE,
	SAT_TAYGETE,
	SAT_CHALDENE,
	SAT_HARPALYKE,
	SAT_KALYKE,
	SAT_IOCASTE,
	SAT_ERINOME,
	SAT_ISONOE,
	SAT_PRAXIDIKE,
	SAT_AUTONOE,
	SAT_THYONE,
	SAT_HERMIPPE,
	SAT_AITNE,
	SAT_EURYDOME,
	SAT_EUANTHE,
	SAT_EUPORIE,
	SAT_ORTHOSIE,
	SAT_SPONDE,
	SAT_KALE,
	SAT_PASITHEE,
	SAT_HEGEMONE,
	SAT_MNEME,
	SAT_AOEDE,
	SAT_THELXINOE,
	SAT_ARCHE,
	SAT_KALLICHORE,
	SAT_HELIKE,
	SAT_CARPO,
	SAT_EUKELADE,
	SAT_CYLLENE,
	SAT_S2003J2,
	SAT_S2003J3,
	SAT_S2003J4,
	SAT_S2003J5,
	SAT_S2003J9,
	SAT_S2003J10,
	SAT_S2003J12,
	SAT_S2003J14,
	SAT_S2003J15,
	SAT_S2003J16,
	SAT_S2003J17,
	SAT_S2003J18,
	SAT_S2003J19,
	SAT_S2003J23,

	SAT_MIMAS,
	SAT_ENCELADUS,
	SAT_TETHYS,
	SAT_DIONE,
	SAT_RHEA,
	SAT_TITAN,
	SAT_HYPERION,
	SAT_IAPETUS,
	SAT_PHOEBE,
	SAT_JANUS,
	SAT_EPIMETHEUS,
	SAT_HELENE,
	SAT_TELESTO,
	SAT_CALYPSO,
	SAT_ATLAS,
	SAT_PROMETHEUS,
	SAT_PANDORA,
	SAT_PAN,
	SAT_METHONE,
	SAT_PALLENE,
	SAT_POLYDEUCES,
	SAT_DAPHNIS,
	SAT_YMIR,
	SAT_PAALIAQ,
	SAT_TARVOS,
	SAT_IJIRAQ,
	SAT_SUTTUNGR,
	SAT_KIVIUQ,
	SAT_MUNDILFARI,
	SAT_ALBIORIX,
	SAT_SKATHI,
	SAT_ERRIAPO,
	SAT_SIARNAQ,
	SAT_THRYMR,
	SAT_NARVI,
	SAT_AEGIR,
	SAT_BEBHIONN,
	SAT_BERGELMIR,
	SAT_BESTLA,
	SAT_FARBAUTI,
	SAT_FENRIR,
	SAT_FORNJOT,
	SAT_HATI,
	SAT_HYROKKIN,
	SAT_KARI,
	SAT_LOGE,
	SAT_SKOLL,
	SAT_SURTUR,
	SAT_S2004_S7,
	SAT_S2004_S12,
	SAT_S2004_S13,
	SAT_S2004_S17,
	SAT_S2006_S1,
	SAT_S2006_S3,
	SAT_S2006_S4,
	SAT_S2006_S6,
	SAT_S2007_S1,
	SAT_S2007_S2,
	SAT_S2007_S3,

	SAT_ARIEL,
	SAT_UMBRIEL,
	SAT_TITANIA,
	SAT_OBERON,
	SAT_MIRANDA,
	SAT_CORDELIA,
	SAT_OPHELIA,
	SAT_BIANCA,
	SAT_CRESSIDA,
	SAT_DESDEMONA,
	SAT_JULIET,
	SAT_PORTIA,
	SAT_ROSALIND,
	SAT_BELINDA,
	SAT_PUCK,
	SAT_PERDITA,
	SAT_MAB,
	SAT_CUPID,
	SAT_CALIBAN,
	SAT_SYCORAX,
	SAT_PROSPERO,
	SAT_SETEBOS,
	SAT_STEPHANO,
	SAT_TRINCULO,
	SAT_S2001_U2,
	SAT_S2001_U3,
	SAT_S2003_U3,

	SAT_TRITON,
	SAT_NEREID,
	SAT_NAIAD,
	SAT_THALASSA,
	SAT_DESPINA,
	SAT_GALATEA,
	SAT_LARISSA,
	SAT_PROTEUS,
	SAT_S2002_N1,
	SAT_S2002_N2,
	SAT_S2002_N3,
	SAT_S2003_N1,
	SAT_S2002_N4,

	SAT_CHARON,
	SAT_NIX,
	SAT_HYDRA
};



//-------------
//  Functions
//-------------

//--  Number
int			get_satellites_num();

//---  Planet ID
int		get_satellite_planet_index(int idx);


//--  Name
bilingual	get_satellite_name(int idx);



//--  Size
void		get_satellite_size(int mode, int idx, double& Rx, double& Ry, double& Rz);

//--  Textures
void		load_satellites_textures_sub(int shrink_rate);
int			get_satellite_texture_index(int idx);

//--  Position
vector3d	get_satellite_position(int idx);
void		set_satellite_position(int idx, const vector3d& pos);


vector3d	calc_satellite_orbit_pos(int idx, const double& t, float phi);
vector3d	get_satellite_position_relative_to_planet(int idx);


#endif
